package org.ferris.bible.jmce.daily;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * TODO Add brief description of type.
 */
public class DailyCalendar implements Serializable
{
	private static final long serialVersionUID = 2348087641775590006L;
	
	private int day, month, year;
	
	private void init(int year, int month, int day) {
		setDay(day);
		setMonth(month);
		setYear(year);
	}
	
	/**
	 * Creates a new DailyCalendar.
	 * @param year
	 * @param month
	 * @param day
	 */
	public DailyCalendar(int year, int month, int day) {
		super();
		init(year,month,day);
	}
	
	
	
	/**
	 * Creates a new DailyCalendar.
	 * @param instance
	 */
	public DailyCalendar(Calendar calendar) 
	{
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-d");		
		String [] tokens = sdf.format(calendar.getTime()).split("-");
		init(
			 Integer.parseInt(tokens[0])
			,Integer.parseInt(tokens[1])
			,Integer.parseInt(tokens[2])
		);
	}



	private void setDay(int day) {
		this.day = day;
	}
	private void setMonth(int month) {
		this.month = month;
	}
	private void setYear(int year) {
		this.year = year;
	}



	public int getMonth() {
		return this.month;
	}	
	public int getDay() {
		return this.day;
	}	
	public int getYear() {
		return this.year;
	}
	
	
	public String getMonthSlashDay() {
		return getMonth() + "/" + getDay();
	}
	
	public String getMonthWithTwoDigits() {
		if (getMonth() < 10) {
			return "0" + getMonth();
		}
		else {
			return getMonth() + "";
		}
	}		
	
	public String getDayWithTwoDigits() {
		if (getDay() < 10) {
			return "0" + getDay();
		}
		else {
			return getDay() + "";
		}
	}
	
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + day;
		result = prime * result + month;
		result = prime * result + year;
		return result;
	}
	
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		DailyCalendar other = (DailyCalendar) obj;
		if (day != other.day) {
			return false;
		}
		if (month != other.month) {
			return false;
		}
		if (year != other.year) {
			return false;
		}
		return true;
	}
	
	
	
	
}