package org.ferris.bible.jmce.daily;

import java.lang.reflect.Proxy;

/**
 * TODO Add brief description of type.
 */
public class DailyReadingFactory 
{
	public static DailyReading getDailyReading() {
		return getProxy(
			new DailyReadingImpl()
		);
	}
	
	public static DailyReading getDailyReading(final String passage) 
	{
		DailyReadingImpl impl = new DailyReadingImpl();
		impl.setPassage(passage);
		return getProxy(impl);
	}
	
	private static DailyReading getProxy(DailyReadingImpl reading) {
		return (DailyReading) Proxy.newProxyInstance(
	    		   DailyReading.class.getClassLoader()
	    		 , new Class[] { DailyReading.class }
	    		 , reading
	     );
	}
}
