package org.ferris.bible.jmce.daily;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import org.apache.log4j.Logger;
import org.ferris.bible.jmce.passage.PassageFactory;


/**
 * TODO Add brief description of type.
 */
public class DailyReadingImpl implements DailyReading, InvocationHandler
{	
	private static final long serialVersionUID = 8893764013327378955L;
	private Logger log = Logger.getLogger(getClass());
	private String passage;
	private String contents;
	
	
	public String getPassage() {
		return passage;
	}
	public void setPassage(String passage) {
		this.passage = passage;
	}
	
	
	public String getContents() {
		return contents;
	}
	public void setContents(String contents) {
		this.contents = contents;
	}
	

	/**
	 * {@inheritDoc}
	 */
	public Object invoke(Object proxy, Method method, Object[] args)
	throws Throwable 
	{
		if (method.getName().equals("getContents"))
		{
			if (getContents() == null && getPassage() != null) 
			{
				log.info(String.format("Lookup \"%s\"",getPassage()));
				try {
					setContents(
						PassageFactory.getPassage(getPassage()).getHtml()
					);
				} catch (Throwable t) {
					log.fatal(t.getMessage(), t);
					setContents("UNAVAILABLE: " + t.getMessage());;
				}
			}
			return getContents();
		}
		else {
			return method.invoke(this, args);
		}
	}	
}
