package org.ferris.bible.jmce.daily;

import org.ferris.bible.jmce.util.PropertiesFactory;

/**
 */
public class DailyReadingsEmailMessage 
{
	
	private DailyReadings dailyReadings;
	private DailyReadings getDailyReadings() { return dailyReadings; }
	private void setDailyReadings(DailyReadings dailyReadings) { this.dailyReadings = dailyReadings; }
	
	/**
	 * Creates a new DailyReadingsEmailMessage.
	 * @param dailyReadings
	 */
	public DailyReadingsEmailMessage(DailyReadings dailyReadings) {
		super();
		setDailyReadings(dailyReadings);
	}
	
	
	
	private String fromAddress = null;
	/**
	 * Returns the "from" address of the e-mail
	 */
	public String getFromAddress() 
	{
		if (fromAddress ==  null) {
			fromAddress = PropertiesFactory.getFromAddress();
		}
		return fromAddress;
	}
	
	private String fromName = null;
	/**
	 * Returns the "from" name of the e-mail
	 */
	public String getFromName() 
	{
		if (fromName == null) {
			fromName = PropertiesFactory.getFromName();
		}
		return fromName;
	}
	
	
	private String toAddress = null;
	/**
	 * Returns the "to" address of the e-mail
	 */
	public String getToAddress() 
	{
		if (toAddress ==  null) {
			toAddress = PropertiesFactory.getToAddress();
		}
		return toAddress;
	}
	
	private String toName = null;
	/**
	 * Returns the "to" name of the e-mail
	 */
	public String getToName() 
	{
		if (toName == null) { 
			toName = PropertiesFactory.getToName();
		}
		return toName;
	}
	
	
	/**
	 * Returns the message of the e-mail
	 */
	public String getMessage()
	{
		return getDailyReadings().toHtml();
	}
	
	
	private String subject = null;
	/**
	 * Returns the subject of the e-mail
	 * @return
	 */
	public String getSubject() 
	{
		if (subject == null) {
			subject = 
				"Daily Bible Readings For"
				+ " " 
				+ getDailyReadings().getDailyCalendar().getMonthSlashDay()
			;
		}
		return subject;
	}	
}
