package org.ferris.bible.jmce.daily;

public class DailyReadingsFactory
{
	public static DailyReadings getDailyReadings()
	{
		return new DailyReadings();		
	}
	
	public static DailyReadings getDailyReadings(String tabDelimitedData)
	{
		String [] tokens
			= tabDelimitedData.split("\t", -1);
		if (tokens.length != 6) {
			throw new RuntimeException(
                   String.format("Line does not have 6 tokens, it has %d tokens: %s", tokens.length, tabDelimitedData)
            );
		}
		
		int month = -1;
		try {
			month = Integer.parseInt(tokens[0]);
		} catch (NumberFormatException e) {
			throw new RuntimeException("The month is not numeric", e);
		}
		
		int day = -1;
		try {
			day = Integer.parseInt(tokens[1]);
		} catch (NumberFormatException e) {
			throw new RuntimeException("The day is not numeric", e);
		}
		
		return new DailyReadings(
			  month
			, day
            , tokens[2]
            , tokens[3]
            , tokens[4]
            , tokens[5]
		);
	}
}
