/*
 *  Copyright 2010 mremijan.
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *       http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  under the License.
 */

package org.ferris.bible.jmce.main;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author mremijan
 */
public class WriteScheduleFile
{
    public static final void main(String [] args)
    throws Exception
    {
        System.out.printf("Welcome to WriteScheduleFile!!\n\n");

        GregorianCalendar gc = new GregorianCalendar();
        gc.set(2011, Calendar.JANUARY, 1);


        StringWriter swriter = new StringWriter();
        PrintWriter writer =  new PrintWriter(swriter);

        String outputPattern = "%s\t%s\t%s\t%s\t%s\t%s\n";

        writer.printf(
                outputPattern
               , "Month"            // month
               , "Day"              // day
               , "Gospel"           // gospel
               , "New Testament"    // new testament
               , "Wisdom"           // wisdom
               , "Old Testament"    // old testament
               , "\n"
         );             

        for (int year=gc.get(Calendar.YEAR); year==2011; year=gc.get(Calendar.YEAR))
        {
            int dayOfWeek
                = gc.get(Calendar.DAY_OF_WEEK);

            switch (dayOfWeek) {
                case Calendar.SATURDAY:
                case Calendar.SUNDAY:
                    break;
                default:
                    writer.printf(
                        outputPattern
                       , getMonth(gc)           // month
                       , getDay(gc)             // day
                       , getGospel()            // gospel
                       , getNewTestament()      // new testament
                       , getWisdom()            // wisdom
                       , getOldTestament()      // old testament
                       , "\n"
                    );
                    break;
            }



            gc.add(Calendar.DAY_OF_MONTH, 1);
        }

        writer.flush();
        System.out.print(swriter.toString());
        File f = new File("C:\\Documents and Settings\\mremijan.SHERPA\\My Documents\\NetBeansProjects\\ferris-bible\\jmce\\src\\main\\resources\\org\\ferris\\bible\\jmce\\schedule\\Book1.txt");
        FileOutputStream fos = new FileOutputStream(f);
        fos.write(swriter.toString().getBytes("UTF-8"));
        fos.flush(); fos.close();
        
        System.out.printf("\n\nGood-Bye!\n");
    }

    private static final String getOldTestament() {
        return "";
    }

    private static final String getWisdom() {
        return "";
    }

    static class Chapter {
        String name;
        int chapters;
        public Chapter(String n, int c) {
            this.name = n; this.chapters = c;
        }
        int current=0;
    }

    private static List<Chapter> toRead;

    static
    {
        toRead = new LinkedList<Chapter>();
        toRead.add(new Chapter("Matthew", 28));
        toRead.add(new Chapter("Mark", 16));
        toRead.add(new Chapter("Luke", 24));
        toRead.add(new Chapter("John", 21));
        toRead.add(new Chapter("Acts", 28));
        toRead.add(new Chapter("Romans", 16));
        toRead.add(new Chapter("1 Corinthians", 16));
        toRead.add(new Chapter("2 Corinthians", 13));
        toRead.add(new Chapter("Galatians",6));
        toRead.add(new Chapter("Ephesians",6));
        toRead.add(new Chapter("Philippians",4));
        toRead.add(new Chapter("Colossians",4));
        toRead.add(new Chapter("1 Thessalonians",5));
        toRead.add(new Chapter("2 Thessalonians",3));
        toRead.add(new Chapter("1 Timothy",6));
        toRead.add(new Chapter("2 Timothy",4));
        toRead.add(new Chapter("Titus",3));
        toRead.add(new Chapter("Philemon",1));
        toRead.add(new Chapter("Hebrews",13));
        toRead.add(new Chapter("James",5));
        toRead.add(new Chapter("1 Peter",5));
        toRead.add(new Chapter("2 Peter",3));
        toRead.add(new Chapter("1 John",5));
        toRead.add(new Chapter("2 John",1));
        toRead.add(new Chapter("3 John",1));
        toRead.add(new Chapter("Jude 1",1));
        toRead.add(new Chapter("Revelation",22));


    }
    private static final String getNewTestament() {
        if (toRead.isEmpty()) {
            return "";
        }
        Chapter c = toRead.get(0);
        c.current++;
        if (c.current > c.chapters) {
            toRead.remove(0);
            if (toRead.isEmpty()) {
                return "";
            }
            c = toRead.get(0);
            c.current++;
        }
        return String.format("%s %d", c.name, c.current);
    }

    private static final String getGospel() {
        return "";
    }

    private static final String getDay(GregorianCalendar gc) {
        return String.format("%d", gc.get(Calendar.DAY_OF_MONTH));
    }

    private static final String getMonth(GregorianCalendar gc) {
        return String.format("%d", gc.get(Calendar.MONTH) + 1);
    }

}
