package org.ferris.bible.jmce.passage;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.IOUtils;
import org.apache.log4j.Logger;
import org.ferris.net.runner.HttpResponseHandler;

public class HttpResponseHandlerForBibleGateway implements HttpResponseHandler<Passage> {

    private Logger log = Logger.getLogger(getClass());
    // ????? Encoding
    //private static final String OPEN_DOUBLE_QUOTE = new String(new int[]{226,8364,339},0,3);
    //private static final String  CLOSE_DOUBLE_QUOTE = new String(new int[]{226,8364,65533},0,3);	
    //private static final String OPEN_SINGLE_QUOTE = new String(new int[]{226,8364,732},0,3);
    //private static final String  CLOSE_SINGLE_QUOTE = new String(new int[]{226,8364,8482},0,3);
    // UTF-8 Encoding
    private static final String OPEN_DOUBLE_QUOTE = new String(new int[]{8220}, 0, 1);
    private static final String CLOSE_DOUBLE_QUOTE = new String(new int[]{8221}, 0, 1);
    private static final String OPEN_SINGLE_QUOTE = new String(new int[]{8216}, 0, 1);
    private static final String CLOSE_SINGLE_QUOTE = new String(new int[]{8217}, 0, 1);
    private static final String EMDASH = new String(new int[]{8212}, 0, 1);
    private static final String EMDASH2 = new String(new int[]{8211}, 0, 1);
    private String passage;

    public HttpResponseHandlerForBibleGateway(String passage) {
        this.passage = passage;
    }

    public List<Passage> response(InputStream inputStream) {
        List<Passage> passages = null;

        try {
            String html = IOUtils.toString(inputStream, "UTF-8");

            // replace non-ascii characters.
            {
                html = html
                        .replace(OPEN_DOUBLE_QUOTE, "\"")
                        .replace(CLOSE_DOUBLE_QUOTE, "\"")
                        .replace(OPEN_SINGLE_QUOTE, "'")
                        .replace(CLOSE_SINGLE_QUOTE, "'")
                        .replace(EMDASH, "-")
                        .replace(EMDASH2, "-");
            }

            passages = new ArrayList<Passage>();
            passages.add(
                //getPassageOriginal(html)
                getPassage20110602(html)
            );
                   
        } catch (Throwable t) {
            log.info(t.getMessage());
            t.printStackTrace();
            passages = null;
        }

        return passages;
    }
    
    
    // ------------------------
    // SCREEN SCRAPE 2011-06-02
    // ------------------------
    // Starting on 2011-06-02, the BibleGatway site was updated.
    private Passage getPassage20110602(String html)
    {
        String startLookFor;
        String endLookFor;
        int startIndex;
        int endIndex;
        
        // Look for the start and end of the "heading" of the page content
        {
        
            // START
            startLookFor
                = "<div class='heading passage-class-0'>";           

            startIndex 
                = html.indexOf(startLookFor);			
            
            if (startIndex <= 0) {
                //log.info(html);
                throw new RuntimeException(String.format("The starting \"%s\" I was looking for was not found.",startLookFor));
            }			
            
            // END
            endLookFor 
                = "</div>";
            endIndex =
                html.indexOf(endLookFor, startIndex);		
            
            if (endIndex <= 0) {
                //log.info(html);
                throw new RuntimeException(String.format("The ending \"%s\" I was looking for was not found.",endLookFor));
            }           
        }
        
        
        // If the "heading" of the page content was found OK without any 
        // errors, I can now use this to find the start of the page "content".
        {
            // START
            startIndex = endIndex + endLookFor.length();
            
            // END
            endLookFor
                //= "<div class=\"footnotes\">";
                //= "<!--end of footnotes-->";
                = "<div class=\"passage-scroller\">";
            
            endIndex =
                html.indexOf(endLookFor, startIndex);
            
            if (endIndex <= 0) {
                //log.info(html);
                throw new RuntimeException(String.format("The ending \"%s\" I was looking for was not found.",endLookFor));
            } 
        }
        
        // If the "content" of the page was found OK without any error,
        // then I think I am good to go!
        return
            new Passage(
                    "<style> * { font-family:verdana; } span.sup { Vertical-align:super;font-size:8pt; font-weight:bold; } </style>"
                    +
                    "\n"
                    +
                    "<h3>"+passage+"&nbsp;(New Living Translation)</h3>"
                    +
                    "\n"
                    +
                    html.substring(startIndex,endIndex)
                    +
                    "</div>"
            );    
    }
    
    
    private Passage getPassageOriginal(String html)
    {
        int startDivIndex =
                html.indexOf("<div class=\"result-text-style-normal\">");

        if (startDivIndex <= 0) {
            //log.info(html);
            throw new RuntimeException("The <div> tag starting the passage was not found.");
        }

        int endDivIndex =
                html.indexOf("</div>", startDivIndex);

        if (endDivIndex <= 0) {
            //log.info(html);
            throw new RuntimeException("The </div> tag ending the passage was not found.");
        }


        return
            new Passage(
            "<style> * { font-family:verdana; } span.sup { Vertical-align:super;font-size:8pt; font-weight:bold; } </style>"
            + "\n"
            + "<h3>" + passage + "&nbsp;(New Living Translation)</h3>"
            + "\n"
            + html.substring(startDivIndex, endDivIndex)
            + "</div>")
        ;        
    }
    
}