package org.ferris.bible.jmce.passage;

import java.util.List;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.apache.commons.lang.StringUtils;

import org.apache.log4j.Logger;

public class PassageFactory 
{
	private static Logger log = Logger.getLogger(PassageFactory.class);
	
	public static Passage getPassage(String passageQuery) 
	{
            if (StringUtils.trimToNull(passageQuery) == null) {
                throw new IllegalArgumentException("the 'passageQuery' parameter is null");
            }

		// Create Runner
		log.info("Create HttpRequestRunnerForBibleGateway");
		HttpRequestRunnerForBibleGateway 
			bibleGateway = new HttpRequestRunnerForBibleGateway();                
		
		// Build Query
		log.info("Build query");
		StringBuilder query = new StringBuilder();
		query.append("/passage/");
		query.append("?");
		query.append("version=?");
		query.append("&");
		query.append("search=?");
		log.info("Query: " + query.toString());
				
		log.info("Setting query parameters");
		//bibleGateway.addParameter("51");
                bibleGateway.addParameter("NLT");
		bibleGateway.addParameter(passageQuery);
		
		log.info("Running Query");
                List<Passage> passages = null;
                try {
                    passages
			= bibleGateway.get(query.toString(), new HttpResponseHandlerForBibleGateway(passageQuery));
                } catch (RuntimeException t) {
                    log.fatal("RuntimeException: " + t.getClass().getName(),t);
                    throw t;
                }
		
		log.info("Return passage");
		if (passages != null) {
			return passages.get(0);
		} else {
			return null;
		}
		
	}
}
