package org.ferris.bible.jmce.util;

import java.io.IOException;
import java.util.Properties;

public final class PropertiesFactory 
{
	private static Properties properties;
	
	private static final Properties getProperties() 
	{
		if (properties == null) {			
			try {
				properties = new Properties();
				properties.load(
					PropertiesFactory
					.class
					.getResourceAsStream("/ferris-bible-jmce-private.properties")
				);
			} catch (IOException e) {
				throw new RuntimeException(e.getMessage(),e);
			}
		}
		return properties;
	}
	
	private static final String getProperty(String key) {
		return getProperties().getProperty(key);
	}

	public static String getHost() {
		return getProperty("host");
	}

	public static String getFromAddress() {
		return getProperty("from_address");
	}

	public static String getFromName() {
		return getProperty("from_name");
	}

	public static String getToAddress() {
		return getProperty("to_address");
	}

	public static String getToName() {
		return getProperty("to_name");
	}
}
